<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;
use Seka\Portal\Modul\Vzdelavanie\Enums\ModelStatusEnum;
use Seka\Portal\Modul\Vzdelavanie\Models\Testovanie\HodnotenieOdpovedeEnum;
use Seka\Portal\Modul\Vzdelavanie\Models\Testovanie\Odpoved;

/**
 * Class UpdateVzdelavanieTestovanieOdpovedeTable
 */
return new class extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up(): void
    {
        Schema::table('vzdelavanie_testovanie_odpovede', function (Blueprint $table) {
            $table
                 ->renameColumn('spravna', 'hodnotenie');
            $table
                 ->string('hodnotenie')
                 ->change()
                 ->default(HodnotenieOdpovedeEnum::NESPRAVNA->name);
            $table
                ->string('stav')
                ->default(ModelStatusEnum::NEPUBLIKOVANE->name)
                ->after('hodnotenie');
        });


        Odpoved::query()->take(10)->each(function (Odpoved $odpoved) {
            $odpoved->setAttribute(
                'hodnotenie',
                ($odpoved->hodnotenie === 'true') ? HodnotenieOdpovedeEnum::SPRAVNA->name : HodnotenieOdpovedeEnum::NESPRAVNA->name,
            );
            $odpoved->save();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down(): void
    {
        Schema::table('vzdelavanie_testovanie_otazky', function (Blueprint $table) {
            $table->boolean('hodnotenie')->change()->default(false);
            $table->renameColumn('hodnotenie', 'spravna');
            $table->dropColumn('stav');
        });
    }
};
